#import "Control.h"

@implementation Control

NSString* uSearchC;
NSString* urlC;
NSMutableString* uSearchOkC;

// quit app
- (void)quit:(id)sender
{
	[[NSApplication sharedApplication] terminate:sender];
}

// about window related methods
- (IBAction)about:(id)sender
{
	[NSApp activateIgnoringOtherApps:YES]; 
	[AboutWindow center];
	[AboutWindow makeKeyAndOrderFront:sender];
}

- (IBAction)closeAbout:(id)sender
{
	[AboutWindow orderOut:sender];
}

- (IBAction)donate:(id)sender
{
	[[NSWorkspace sharedWorkspace] openURL:[NSURL URLWithString:@"https://www.paypal.com/xclick/business=galliva%40ticino.com&item_name=iWiki&no_note=1&tax=0&currency_code=USD"]];
}

// set-URL window related methods
- (IBAction)URL:(id)sender
{
	[NSApp activateIgnoringOtherApps:YES]; 
	[URLWindow center];
	[URLWindow makeKeyAndOrderFront:sender];
}

- (IBAction)closeURL:(id)sender
{
	NSString* cont;
	cont = [textURL stringValue];
	[cont writeToFile:@"/Library/Preferences/.iwiki" atomically:YES];
	[URLWindow orderOut:sender];
}

// search window related methods
- (IBAction)search:(id)sender
{
	[NSApp activateIgnoringOtherApps:YES]; 
	[SearchWindow center];
	[SearchWindow makeKeyAndOrderFront:sender];
}

- (IBAction)closeSearch:(id)sender
{
	urlC = [textURL stringValue];
	uSearchC = [textSearch stringValue];
	
	// 'normalize' URL
    uSearchOkC = [NSMutableString stringWithString:uSearchC];
    [uSearchOkC replaceOccurrencesOfString:@" " withString:@"_" options:NSLiteralSearch range:NSMakeRange(0,[uSearchOkC length])];
	
	urlC = [urlC stringByAppendingString: uSearchOkC];
	
	[[NSWorkspace sharedWorkspace] openURL:[NSURL URLWithString:urlC]];
	[SearchWindow orderOut:sender];
}

- (void)controlTextDidEndEditing:(NSNotification *)theNotification
{
	[self closeSearch: self];
}


// notifications
- (void)launchSearch:(NSNotification *)notif
{
	[self search:self];
}

@end
