#import "Wiki.h"

@implementation Wiki

NSString* url;
NSString* uSearch;
NSMutableString* uSearchOk;

NSString* fileContents;	
NSArray *lines;

- (void)applicationDidFinishLaunching:(NSNotification *)notification
{
	// status bar menu
	NSStatusItem    *statusItem;
	statusItem = [[[NSStatusBar systemStatusBar] statusItemWithLength:NSSquareStatusItemLength] retain];
	[statusItem setHighlightMode:YES];
	[statusItem setTitle:@"W!"];
	[statusItem setMenu:upMenu];
	[statusItem setEnabled:YES];
	
	NSFileManager *manager = [NSFileManager defaultManager];
	if ([manager fileExistsAtPath: @"/Library/Preferences/.iwiki"])
	{
		//read prefs
		fileContents = [NSString stringWithContentsOfFile:@"/Library/Preferences/.iwiki"];
		lines=[fileContents componentsSeparatedByString:@"XXX"];
		[textURL  setStringValue: [lines objectAtIndex: 0]];
	}
	else
	{
		[firstWindow center];
		[firstWindow makeKeyAndOrderFront:notification];

		NSString* cont;
		cont = @"http://www.wikipedia.org/";
		[cont writeToFile:@"/Library/Preferences/.iwiki" atomically:YES];
		[textURL  setStringValue: cont];
	}
	
	// set services
    [NSApp setServicesProvider:self];
	
	// notifications: I register the control class notifications
	[[NSNotificationCenter defaultCenter] addObserver:ControlClass selector:@selector(launchSearch:) name:@"search" object:nil];
	
	//hotkeys
	[self registerHotKeys];
}

- (void)eseguiServizio:(NSPasteboard *)pboard userData:(NSString *)userData error:(NSString **)error
{
    [pboard types];
	
	url = [textURL stringValue];
	uSearch = [pboard stringForType:NSStringPboardType];

	// 'normalize' URL
    uSearchOk=[NSMutableString stringWithString:uSearch];
    [uSearchOk replaceOccurrencesOfString:@" " withString:@"_" options:NSLiteralSearch range:NSMakeRange(0,[uSearchOk length])];
	
	url = [url stringByAppendingString: uSearchOk];
	
	[[NSWorkspace sharedWorkspace] openURL:[NSURL URLWithString:url]];
}

// -----------------------
// hotkeys implementations
// -----------------------

static id   applicazione=nil;

+ (id)nuovoOggetto
{
    if(applicazione != nil )
        return applicazione;
	
    applicazione = [[Wiki alloc] init];
    return applicazione;
}

// show the search window
- (IBAction)mostra:(id)sender
{
	NSLog(@"richiamata");
	// notification
	[[NSNotificationCenter defaultCenter] postNotificationName:@"search" object:self userInfo:nil];
}

- (void)registerHotKeys
{
    OSStatus            err;
    EventTypeSpec       eventSpec[2];
    NSEnumerator        *en;
    id                  obj;
    int                 i;
	
    //NSLog(@"registering hot keys");
    eventSpec[0].eventClass=kEventClassKeyboard;
    eventSpec[0].eventKind=kEventHotKeyPressed;
    eventSpec[1].eventClass=kEventClassKeyboard;
    eventSpec[1].eventKind=kEventHotKeyReleased;
    
	EventHandlerRef eventHandlerRef;
	
	err=InstallEventHandler(GetEventDispatcherTarget(),NewEventHandlerUPP((EventHandlerProcPtr)keyEventHandler),2,eventSpec,nil,&eventHandlerRef);
    if(err)
        NSLog(@"Error installing event handler: %d",err);

    {
        EventHotKeyID   hkID={'HKyC',(UInt32) 1};//codiceIdentificativo};
        EventHotKeyRef   hkref;
        UInt32          hotKeyCode,hotKeyModifiers; // da inizializzare
		hotKeyCode=0;
		hotKeyModifiers=768;
		
        //NSLog(@"Installing hot keys");
        err=RegisterEventHotKey(hotKeyCode,hotKeyModifiers,hkID,GetEventDispatcherTarget(),0,&hkref);
        if(err)
            NSLog(@"Error registering hot key!");
    }
}

OSStatus keyEventHandler(EventHandlerCallRef inHandlerRef, EventRef inEvent, void *refCon)
{
    OSStatus   err;
	
    NSLog(@"getting event from OS");
	
    err=[[Wiki nuovoOggetto] handleHotKeyEvent:inEvent];
    if(err)
    {
        NSLog(@"Got an event error: %d",err);
        return err;
    }
	
    return noErr;
}

- (OSStatus)handleHotKeyEvent:(EventRef)theEvent
{
    OSStatus            err;
    EventHotKeyID     hotKeyID;
	
    //NSLog(@"handling hot key event");   
	
	if(GetEventKind(theEvent)==kEventHotKeyPressed)
    {
        NSEnumerator   *en;
        id      obj;
		
        //NSLog(@"Got a hot key pressed event");
        err=GetEventParameter(theEvent,kEventParamDirectObject,
							  typeEventHotKeyID,nil,sizeof(EventHotKeyID),nil,&hotKeyID);
        if(err)
            NSLog(@"Error getting event parameter: %d",err);
		
		if (hotKeyID.id==1) 
		{
			[self mostra: self];
		}
    }
    else
    {
        NSLog(@"Got an event of another kind");
    }
	
    return noErr;
}

@end
